// Garden Gnome Software - Skin
// Pano2VR pro 4.5beta2/10512
// Filename: skin.ggsk
// Generated Mon Feb 24 11:59:45 2014

function pano2vrSkin(player,base) {
	var me=this;
	var flag=false;
	var nodeMarker=new Array();
	var activeNodeMarker=new Array();
	this.player=player;
	this.player.skinObj=this;
	this.divSkin=player.divSkin;
	var basePath="";
	// auto detect base path
	if (base=='?') {
		var scripts = document.getElementsByTagName('script');
		for(var i=0;i<scripts.length;i++) {
			var src=scripts[i].src;
			if (src.indexOf('skin.js')>=0) {
				var p=src.lastIndexOf('/');
				if (p>=0) {
					basePath=src.substr(0,p+1);
				}
			}
		}
	} else
	if (base) {
		basePath=base;
	}
	this.elementMouseDown=new Array();
	this.elementMouseOver=new Array();
	var cssPrefix='';
	var domTransition='transition';
	var domTransform='transform';
	var prefixes='Webkit,Moz,O,ms,Ms'.split(',');
	var i;
	for(i=0;i<prefixes.length;i++) {
		if (typeof document.body.style[prefixes[i] + 'Transform'] !== 'undefined') {
			cssPrefix='-' + prefixes[i].toLowerCase() + '-';
			domTransition=prefixes[i] + 'Transition';
			domTransform=prefixes[i] + 'Transform';
		}
	}
	
	this.player.setMargins(0,0,0,0);
	
	this.updateSize=function(startElement) {
		var stack=new Array();
		stack.push(startElement);
		while(stack.length>0) {
			e=stack.pop();
			if (e.ggUpdatePosition) {
				e.ggUpdatePosition();
			}
			if (e.hasChildNodes()) {
				for(i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
	}
	
	parameterToTransform=function(p) {
		var hs='translate(' + p.rx + 'px,' + p.ry + 'px) rotate(' + p.a + 'deg) scale(' + p.sx + ',' + p.sy + ')';
		return hs;
	}
	
	this.findElements=function(id,regex) {
		var r=new Array();
		var stack=new Array();
		var pat=new RegExp(id,'');
		stack.push(me.divSkin);
		while(stack.length>0) {
			e=stack.pop();
			if (regex) {
				if (pat.test(e.ggId)) r.push(e);
			} else {
				if (e.ggId==id) r.push(e);
			}
			if (e.hasChildNodes()) {
				for(i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
		return r;
	}
	
	this.addSkin=function() {
		this._hide_elements=document.createElement('div');
		this._hide_elements.ggId="hide_elements";
		this._hide_elements.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._hide_elements.ggVisible=false;
		this._hide_elements.className='ggskin ggskin_container';
		this._hide_elements.ggType='container';
		this._hide_elements.ggUpdatePosition=function() {
			this.style[domTransition]='none';
			if (this.parentNode) {
				w=this.parentNode.offsetWidth;
				this.style.left=(-43 + w) + 'px';
			}
		}
		hs ='position:absolute;';
		hs+='left: -43px;';
		hs+='top:  9px;';
		hs+='width: 30px;';
		hs+='height: 30px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: hidden;';
		this._hide_elements.setAttribute('style',hs);
		this._active=document.createElement('div');
		this._active.ggId="active";
		this._active.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._active.ggVisible=true;
		this._active.className='ggskin ggskin_rectangle';
		this._active.ggType='rectangle';
		hs ='position:absolute;';
		hs+='left: -1px;';
		hs+='top:  -1px;';
		hs+='width: 28px;';
		hs+='height: 28px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='background: #ffffff;';
		hs+='border: 2px solid #ff0000;';
		hs+='border-radius: 999px;';
		hs+=cssPrefix + 'border-radius: 999px;';
		this._active.setAttribute('style',hs);
		this._hide_elements.appendChild(this._active);
		this._normal=document.createElement('div');
		this._normal.ggId="normal";
		this._normal.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._normal.ggVisible=true;
		this._normal.className='ggskin ggskin_rectangle';
		this._normal.ggType='rectangle';
		hs ='position:absolute;';
		hs+='left: -1px;';
		hs+='top:  -1px;';
		hs+='width: 28px;';
		hs+='height: 28px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='background: #ffffff;';
		hs+='border: 2px solid #000000;';
		hs+='border-radius: 999px;';
		hs+=cssPrefix + 'border-radius: 999px;';
		this._normal.setAttribute('style',hs);
		this._hide_elements.appendChild(this._normal);
		this.divSkin.appendChild(this._hide_elements);
		this._map=document.createElement('div');
		this._map.ggId="Map";
		this._map.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._map.ggVisible=true;
		this._map.className='ggskin ggskin_rectangle';
		this._map.ggType='rectangle';
		hs ='position:absolute;';
		hs+='left: 15px;';
		hs+='top:  13px;';
		hs+='width: 150px;';
		hs+='height: 208px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='background: #ffffff;';
		hs+='border: 1px solid #000000;';
		this._map.setAttribute('style',hs);
		this._marker_1=document.createElement('div');
		this._marker_1.ggId="Marker 1";
		this._marker_1.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._marker_1.ggVisible=true;
		this._marker_1.className='ggskin ggskin_mark';
		this._marker_1.ggType='mark';
		hs ='position:absolute;';
		hs+='left: 15px;';
		hs+='top:  17px;';
		hs+='width: 5px;';
		hs+='height: 5px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='cursor: pointer;';
		this._marker_1.setAttribute('style',hs);
		this._marker_1.ggMarkerNodeId='node_01';
		nodeMarker.push(this._marker_1);
		this._marker_1.onclick=function () {
			me.player.openNext("pano_01_out.xml","");
		}
		this._map.appendChild(this._marker_1);
		this._marker_2=document.createElement('div');
		this._marker_2.ggId="Marker 2";
		this._marker_2.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._marker_2.ggVisible=true;
		this._marker_2.className='ggskin ggskin_mark';
		this._marker_2.ggType='mark';
		hs ='position:absolute;';
		hs+='left: 45px;';
		hs+='top:  82px;';
		hs+='width: 5px;';
		hs+='height: 5px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='cursor: pointer;';
		this._marker_2.setAttribute('style',hs);
		this._marker_2.ggMarkerNodeId='node_02';
		nodeMarker.push(this._marker_2);
		this._marker_2.onclick=function () {
			me.player.openNext("pano_02_out.xml","");
		}
		this._map.appendChild(this._marker_2);
		this._marker_3=document.createElement('div');
		this._marker_3.ggId="Marker 3";
		this._marker_3.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._marker_3.ggVisible=true;
		this._marker_3.className='ggskin ggskin_mark';
		this._marker_3.ggType='mark';
		hs ='position:absolute;';
		hs+='left: 84px;';
		hs+='top:  149px;';
		hs+='width: 5px;';
		hs+='height: 5px;';
		hs+=cssPrefix + 'transform-origin: 50% 50%;';
		hs+='visibility: inherit;';
		hs+='cursor: pointer;';
		this._marker_3.setAttribute('style',hs);
		this._marker_3.ggMarkerNodeId='node_03';
		nodeMarker.push(this._marker_3);
		this._marker_3.onclick=function () {
			me.player.openNext("pano_03_out.xml","");
		}
		this._map.appendChild(this._marker_3);
		this.divSkin.appendChild(this._map);
		this._marker_1__normal=this._normal.cloneNode(true);
		this._marker_1__normal.style.visibility='inherit';
		this._marker_1__normal.style.left=0;
		this._marker_1__normal.style.top=0;
		this._marker_1.ggMarkerNormal=this._marker_1__normal;
		this._marker_1__active=this._active.cloneNode(true);
		this._marker_1__active.style.visibility='hidden';
		this._marker_1__active.style.left=0;
		this._marker_1__active.style.top=0;
		this._marker_1.ggMarkerActive=this._marker_1__active;
		if (this._marker_1.firstChild) {
			this._marker_1.insertBefore(this._marker_1__active,this._marker_1.firstChild);
		} else {
			this._marker_1.appendChild(this._marker_1__active);
		}
		if (this._marker_1.firstChild) {
			this._marker_1.insertBefore(this._marker_1__normal,this._marker_1.firstChild);
		} else {
			this._marker_1.appendChild(this._marker_1__normal);
		}
		this._marker_2__normal=this._normal.cloneNode(true);
		this._marker_2__normal.style.visibility='inherit';
		this._marker_2__normal.style.left=0;
		this._marker_2__normal.style.top=0;
		this._marker_2.ggMarkerNormal=this._marker_2__normal;
		this._marker_2__active=this._active.cloneNode(true);
		this._marker_2__active.style.visibility='hidden';
		this._marker_2__active.style.left=0;
		this._marker_2__active.style.top=0;
		this._marker_2.ggMarkerActive=this._marker_2__active;
		if (this._marker_2.firstChild) {
			this._marker_2.insertBefore(this._marker_2__active,this._marker_2.firstChild);
		} else {
			this._marker_2.appendChild(this._marker_2__active);
		}
		if (this._marker_2.firstChild) {
			this._marker_2.insertBefore(this._marker_2__normal,this._marker_2.firstChild);
		} else {
			this._marker_2.appendChild(this._marker_2__normal);
		}
		this._marker_3__normal=this._normal.cloneNode(true);
		this._marker_3__normal.style.visibility='inherit';
		this._marker_3__normal.style.left=0;
		this._marker_3__normal.style.top=0;
		this._marker_3.ggMarkerNormal=this._marker_3__normal;
		this._marker_3__active=this._active.cloneNode(true);
		this._marker_3__active.style.visibility='hidden';
		this._marker_3__active.style.left=0;
		this._marker_3__active.style.top=0;
		this._marker_3.ggMarkerActive=this._marker_3__active;
		if (this._marker_3.firstChild) {
			this._marker_3.insertBefore(this._marker_3__active,this._marker_3.firstChild);
		} else {
			this._marker_3.appendChild(this._marker_3__active);
		}
		if (this._marker_3.firstChild) {
			this._marker_3.insertBefore(this._marker_3__normal,this._marker_3.firstChild);
		} else {
			this._marker_3.appendChild(this._marker_3__normal);
		}
		this.divSkin.ggUpdateSize=function(w,h) {
			me.updateSize(me.divSkin);
		}
		this.divSkin.ggViewerInit=function() {
		}
		this.divSkin.ggLoaded=function() {
		}
		this.divSkin.ggReLoaded=function() {
		}
		this.divSkin.ggLoadedLevels=function() {
		}
		this.divSkin.ggReLoadedLevels=function() {
		}
		this.divSkin.ggEnterFullscreen=function() {
		}
		this.divSkin.ggExitFullscreen=function() {
		}
		this.skinTimerEvent();
	};
	this.hotspotProxyClick=function(id) {
	}
	this.hotspotProxyOver=function(id) {
	}
	this.hotspotProxyOut=function(id) {
	}
	this.changeActiveNode=function(id) {
		var newMarker=new Array();
		var i,j;
		var tags=me.player.userdata.tags;
		for (i=0;i<nodeMarker.length;i++) {
			var match=false;
			if ((nodeMarker[i].ggMarkerNodeId==id) && (id!='')) match=true;
			for(j=0;j<tags.length;j++) {
				if (nodeMarker[i].ggMarkerNodeId==tags[j]) match=true;
			}
			if (match) {
				newMarker.push(nodeMarker[i]);
			}
		}
		for(i=0;i<activeNodeMarker.length;i++) {
			if (newMarker.indexOf(activeNodeMarker[i])<0) {
				if (activeNodeMarker[i].ggMarkerNormal) {
					activeNodeMarker[i].ggMarkerNormal.style.visibility='inherit';
				}
				if (activeNodeMarker[i].ggMarkerActive) {
					activeNodeMarker[i].ggMarkerActive.style.visibility='hidden';
				}
				if (activeNodeMarker[i].ggDeactivate) {
					activeNodeMarker[i].ggDeactivate();
				}
			}
		}
		for(i=0;i<newMarker.length;i++) {
			if (activeNodeMarker.indexOf(newMarker[i])<0) {
				if (newMarker[i].ggMarkerNormal) {
					newMarker[i].ggMarkerNormal.style.visibility='hidden';
				}
				if (newMarker[i].ggMarkerActive) {
					newMarker[i].ggMarkerActive.style.visibility='inherit';
				}
				if (newMarker[i].ggActivate) {
					newMarker[i].ggActivate();
				}
			}
		}
		activeNodeMarker=newMarker;
	}
	this.skinTimerEvent=function() {
		setTimeout(function() { me.skinTimerEvent(); }, 10);
	};
	function SkinHotspotClass(skinObj,hotspot) {
		var me=this;
		var flag=false;
		this.player=skinObj.player;
		this.skin=skinObj;
		this.hotspot=hotspot;
		this.elementMouseDown=new Array();
		this.elementMouseOver=new Array();
		this.__div=document.createElement('div');
		this.__div.setAttribute('style','position:absolute; left:0px;top:0px;visibility: inherit;');
		
		this.findElements=function(id,regex) {
			return me.skin.findElements(id,regex);
		}
		
		{
			this.__div=document.createElement('div');
			this.__div.ggId="Hotspot";
			this.__div.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
			this.__div.ggVisible=true;
			this.__div.className='ggskin ggskin_hotspot';
			this.__div.ggType='hotspot';
			hs ='position:absolute;';
			hs+='left: 441px;';
			hs+='top:  309px;';
			hs+='width: 5px;';
			hs+='height: 5px;';
			hs+=cssPrefix + 'transform-origin: 50% 50%;';
			hs+='visibility: inherit;';
			hs+='cursor: pointer;';
			this.__div.setAttribute('style',hs);
			this.__div.onclick=function () {
				me.player.openNext(me.hotspot.url,me.hotspot.target);
				me.skin.hotspotProxyClick(me.hotspot.id);
			}
			this.__div.onmouseover=function () {
				me.player.hotspot=me.hotspot;
				me.skin.hotspotProxyOver(me.hotspot.id);
			}
			this.__div.onmouseout=function () {
				me.player.hotspot=me.player.emptyHotspot;
				me.skin.hotspotProxyOut(me.hotspot.id);
			}
			this._hotspot_image=document.createElement('div');
			this._hotspot_image.ggId="hotspot_image";
			this._hotspot_image.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
			this._hotspot_image.ggVisible=true;
			this._hotspot_image.className='ggskin ggskin_rectangle';
			this._hotspot_image.ggType='rectangle';
			hs ='position:absolute;';
			hs+='left: -16px;';
			hs+='top:  -17px;';
			hs+='width: 30px;';
			hs+='height: 30px;';
			hs+=cssPrefix + 'transform-origin: 50% 50%;';
			hs+='visibility: inherit;';
			hs+='background: #0000ff;';
			hs+='background: rgba(0,0,255,0.588235);';
			hs+='border: 2px solid #0000ff;';
			hs+='border-radius: 999px;';
			hs+=cssPrefix + 'border-radius: 999px;';
			this._hotspot_image.setAttribute('style',hs);
			this.__div.appendChild(this._hotspot_image);
		}
	};
	this.addSkinHotspot=function(hotspot) {
		return new SkinHotspotClass(me,hotspot);
	}
	this.addSkin();
};